#include <stdio.h>

//This is my very first C++ program so no laughing is needed.
//Suggestions are always welcome though. (acerboys@hotmail.com)
//Compiled with Borland C++ I don't think this matters though

#define TIMAXTIME 10000
#define lpt_base 0x378
#define lpt_out lpt_base
#define lpt_in	(lpt_base+1)

int get_ti(void);

main(int argc, char *argv[]) {
  int ret,stop=0;
  long bytes=0, totalbytes=16384;
  FILE *fptr;

  if(argc!=2){ printf("Use: dumpxp (page#.bin, tixx.rom)\n");
		printf("Each page = 16384 bytes\n");
		printf("ti86.rom/ti83.rom(whole rom) = 262144 bytes (5 minutes)\n");
		printf("ti82.rom/ti85.rom(whole rom) = 131072 bytes (2 minutes)\n");
		printf("ti92.rom(whole rom) = 1048576 bytes (20 minutes)\n");
		printf("***dumpxp uses LPT1 at 0x378***\n");
		printf("       e.g.:\n");
		printf("            dumpxp ti86.rom\n");
		printf("            dumpxp page0.bin\n");
		exit(1);}

  if (strcmp(argv[1], "ti83.rom") == 0) totalbytes = 262144;
  if (strcmp(argv[1], "ti86.rom") == 0) totalbytes = 262144;
  if (strcmp(argv[1], "ti82.rom") == 0) totalbytes = 131072;
  if (strcmp(argv[1], "ti85.rom") == 0) totalbytes = 131072;
  if (strcmp(argv[1], "ti92.rom") == 0)	totalbytes = 1048576;

  fptr = fopen(argv[1],"wb");
  printf("TIxx Parallel port ROM dump reciever By: Nate Goergen -ESC exits\n\n");
  fflush(stdout);

	printf("Waiting...\r");
	do{
		if(kbhit() != 0 && getch() == 27) exit(1);
		ret=get_ti();
	}while(ret == -1);
	putc(ret, fptr);
	bytes++;

	while(stop != 1)
	{

	if(kbhit() != 0 && getch() == 27) exit(1);
	ret=get_ti();
	putc(ret,fptr);

	bytes++;
	printf("Byte: %ld of %ld\r",bytes,totalbytes);
	if(bytes == totalbytes) stop=1;
	fflush(stdout);
	}

  printf("\nDone!");
  fflush(stdin);
  fclose(fptr);
  return 0;
}


// Receive a byte from the TI
int get_ti(void) {
  int bit,titime=0;
  unsigned char data=0, v;

  for (bit=0; bit<8; bit++) {
	while ((v=inportb(lpt_in)&0x30) == 0x30) if(titime++>TIMAXTIME) return -1;
	if (v==0x10) {
	  data=(data>>1)|0x80;
	  outportb(lpt_out,1);
	  while ((inportb(lpt_in)&0x20)==0x00) if(titime++>TIMAXTIME) return -1;
	  outportb(lpt_out,3);
	} else {
	  data=data>>1;
	  outportb(lpt_out,2);
	  while ((inportb(lpt_in)&0x10)==0x00) if(titime++>TIMAXTIME) return -1;
	  outportb(lpt_out,3);
	}
	inportb(lpt_in);
	inportb(lpt_in);
	inportb(lpt_in);
  }
  return data;
}
